import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public class TestObjects extends JFrame implements Runnable,KeyListener{
    Engine2008 eng;
    Thread t;
    Group gr;
    private static final long serialVersionUID = -4142962802625162757L;
    public TestObjects(){
        super("Astro Solutions TestObject");
        setSize(400,440);
        eng=new Engine2008();
        add(eng);
        eng.setBounds(0,40,400,400);
        t=new Thread(this);
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        t.start();
    }
    public static void main(String[]args){
        new TestObjects();
    }
    public void run(){

        Vektor v1=new Vektor(100,0,0);
        Vektor v2=new Vektor(100,20,0);
        Vektor v3=new Vektor(100,20,20);
        Vektor v4=new Vektor(100,0,20);
        Quad q=new Quad(Color.blue,v1,v2,v3,v4);

        Vektor vy1=new Vektor(100,5,5);
        Vektor vy2=new Vektor(100,15,5);
        Vektor vy3=new Vektor(100,15,15);
        Vektor vy4=new Vektor(100,5,15);
        Quad qy=new Quad(Color.gray,vy1,vy2,vy3,vy4);

        Vektor vx1=new Vektor(70,10,10);
        Vektor vx2=new Vektor(70,15,10);
        Vektor vx3=new Vektor(70,15,15);
        Vektor vx4=new Vektor(70,10,15);
        Quad qx=new Quad(Color.black,vx1,vx2,vx3,vx4);

        Vektor vb1=new Vektor(100,0,0);
        Vektor vb2=new Vektor(95,-20,0);
        Vektor vb3=new Vektor(90,-20,-20);
        Triangle t=new Triangle(Color.red,vb1,vb2,vb3);

        Vektor vc=new Vektor(80,-40,-40);
        Kugel k=new Kugel(Color.green,vc,10);

        PaintGroup pg=new PaintGroup();
        q.setPaintGroup(pg);
        qy.setPaintGroup(pg);

        gr=new Group();
        gr.add(q);
        gr.add(qx);

        eng.add(gr);
        eng.add(qy);
        eng.add(t);
        eng.add(k);
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        process(e);
//System.out.println("kpressed"+key);
    }
    public void keyReleased(KeyEvent e){
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==KeyEvent.VK_UP){
                eng.rotUp(Math.PI/90);
            }
            if(key==KeyEvent.VK_DOWN){
                eng.rotUp(-Math.PI/90);
            }
            if(key==KeyEvent.VK_LEFT){
                eng.rotLeft(Math.PI/90);
            }
            if(key==KeyEvent.VK_RIGHT){
                eng.rotLeft(-Math.PI/90);
            }
            if(key==KeyEvent.VK_DELETE){
                eng.transform(-5,0,0);
            }
            if(key==KeyEvent.VK_INSERT){
                eng.remove(gr);
            }
            if(key==KeyEvent.VK_ESCAPE||key==27){
                System.exit(0);
            }
    }
}
